$ssScoreHudInterval = 1;
$ssScoreHudShowReturner = false;
$ssScoreFriendlySwitch = 0;
$ssScoreEnemySwitch = 0;

function ssScoreHudHandleFlag(%msgType, %msgString, %clientName, %flagTeam, %flagTeamId) {
	objectivehud.visible = true;
	if ($ssScoreHudTeamId != 1 && $ssScoreHudTeamId != 2)
		return;
	%msgType = detag(%msgType);
	%clientName = detag(%clientName);
	%flagTeamId = detag(%flagTeamId);
	switch$(%msgType) {
		case "MsgCTFFlagTaken":
			if (%flagTeamId == $ssScoreHudTeamId) {
				cancel($ssScoreHudFriendlySchedule);
				SSFriendlyScoreHud.setBitmap("ssflag_friendly_taken.png");
				SSFriendlyScoreHudText.setText(%clientName);
			} else {
				cancel($ssScoreHudEnemySchedule);
				SSEnemyScoreHud.setBitmap("ssflag_enemy_taken.png");
				SSEnemyScoreHudText.setText(%clientName);
			}
		case "MsgCTFFlagDropped":
			if (%flagTeamId == $ssScoreHudTeamId) {
				SSFriendlyScoreHud.setBitmap("ssflag_friendly_taken.png");
				ssScoreHudFriendlyTimer(45);
			} else {
				SSEnemyScoreHud.setBitmap("ssflag_enemy_taken.png");
				ssScoreHudEnemyTimer(45);
			}
		case "MsgCTFFlagReturned":
			if (%flagTeamId == $ssScoreHudTeamId) {
				cancel($ssScoreHudFriendlySchedule);
				$ssScoreHudFriendlyTime = 0;
				SSFriendlyScoreHud.setBitmap("ssflag_friendly.png");
				if ($ssScoreHudShowReturner) {
					SSFriendlyScoreHudText.setText("\c7\xab " @ %clientName);
					SSFriendlyScoreHudText.schedule(3000, setText, "");
				} else
					SSFriendlyScoreHudText.setText("");
			} else {
				cancel($ssScoreHudEnemySchedule);
				$ssScoreHudEnemyTime = 0;
				SSEnemyScoreHud.setBitmap("ssflag_enemy.png");
				if ($ssScoreHudShowReturner) {
					SSEnemyScoreHudText.setText("\c7\xab " @ %clientName);
					SSEnemyScoreHudText.schedule(3000, setText, "");
				} else
					SSEnemyScoreHudText.setText("");
			}
		case "MsgCTFFlagCapped":
			if (%flagTeamId == $ssScoreHudTeamId) {
				SSFriendlyScoreHud.setBitmap("ssflag_friendly.png");
				SSFriendlyScoreHudText.setText("");
			} else {
				SSEnemyScoreHud.setBitmap("ssflag_enemy.png");
				SSEnemyScoreHudText.setText("");
			}
	}
}

function ssScoreHudHandleScore(%msgType, %msgString, %teamId, %teamScore) {
	if ($ssScoreHudTeamId $= "")
		$ssScoreHudTeamId = "0";
	if (%teamId == $ssScoreHudTeamId)
		$ssScoreHudFriendlyScore = %teamScore;
	else
		$ssScoreHudEnemyScore = %teamScore;
	ssScoreHudDrawScores();
}

function ssScoreHudDrawScores() {
	SSFriendlyScoreHudScore.setText($ssScoreHudFriendlyScore);
	SSEnemyScoreHudScore.setText($ssScoreHudEnemyScore);
}

function ssScoreHudHandleCheckTeamLines(%msgType, %msgString, %teamId) {
	$ssScoreHudTeamId = %teamId != 0 ? %teamId : 1;
	if ($ssScoreHudOldTeam != $ssScoreHudTeamId && ObjectiveHud.GameType $= "CTFGame") {
		$ssScoreHudFriendlyScore = SSEnemyScoreHudScore.getValue();
		$ssScoreHudEnemyScore = SSFriendlyScoreHudScore.getValue();
		ssScoreHudDrawScores();
		%friendlyText = SSFriendlyScoreHudText.getValue();
		SSFriendlyScoreHudText.setText(SSEnemyScoreHudText.getValue());
		SSEnemyScoreHudText.setText(%friendlyText);
		SSFriendlyScoreHud.setBitmap((SSFriendlyScoreHudText.getValue() $= "") ? "ssflag_friendly.png" : "ssflag_friendly_taken.png");
		SSEnemyScoreHud.setBitmap((SSEnemyScoreHudText.getValue() $= "") ? "ssflag_enemy.png" : "ssflag_enemy_taken.png");
		if (isEventPending($ssScoreHudFriendlySchedule)) {
			$ssScoreFriendlySwitch = $ssScoreHudFriendlyTime;
			$ssScoreHudFriendlyTime = $ssScoreEnemySwitch;
		}
		if (isEventPending($ssScoreHudEnemySchedule)) {
			$ssScoreEnemySwitch = $ssScoreHudEnemyTime;
			$ssScoreHudEnemyTime = $ssScoreFriendlySwitch;
		}
	}
	$ssScoreHudOldTeam = $ssScoreHudTeamId;
}

function ssScoreHudHandleCTFAddTeam(%msgType, %msgString, %teamId, %teamName, %flagStatus, %teamScore) {
	%flagStatus = detag(%flagStatus);
	switch$(%flagStatus) {
		case "<At Base>":
			%flagStatus = "";
		case "<In the Field>":
			%flagStatus = "\c0\x8b\c7?\c0\x9b";
	}
	if ($ssScoreHudTeamId == %teamId) {
		$ssScoreHudFriendlyScore = %teamScore;
		SSFriendlyScoreHudText.setText(%flagStatus);
	} else {
		$ssScoreHudEnemyScore = %teamScore;
		SSEnemyScoreHudText.setText(%flagStatus);
	}
	ssScoreHudDrawScores();
}

package ssScoreHud {
	function DispatchLaunchMode() {
		parent::DispatchLaunchMode();
		ssMakeScoreHud();
	}

	function disconnect() {
		parent::disconnect();
		ssScoreHudReset();
	}
	
	function setupObjHud(%gameType) {
		parent::setupObjHud(%gameType);
		%tr2 = (detag(%gameType) $= "TR2Game");
		SSScoreHudCarrierName.setVisible(%tr2);
		SSScoreHudCarrierHealth.setVisible(%tr2);
		SSFriendlyScoreHudText.setVisible(!%tr2);
		SSEnemyScoreHudText.setVisible(!%tr2);
		$ssScoreHudOldTeam = $ssScoreHudTeamId = 1;
		ssScoreHudReset();
	}
	
	function ObjectiveHud::setVisible(%this, %visible) {
		%val = (ObjectiveHud.GameType $= "TR2Game" || ObjectiveHud.GameType $= "CTFGame");
		if (%val) {
			parent::setVisible(%this,false);
			ssShowScoreHud(true);
		} else {
			parent::setVisible(%this,%visible);
			ssShowScoreHud(false);
		}
	}
};
activatePackage(ssScoreHud);

function ssShowScoreHud(%val) {
	SSFriendlyScoreHudFrame.setVisible(%val);
	SSEnemyScoreHudFrame.setVisible(%val);
}

function ssScoreHudFriendlyTimer(%time, %pass) {
	if ($ssScoreFriendlySwitch != 0 && !%pass) {
		ssScoreHudEnemyTimer($ssScoreFriendlySwitch - $ssScoreHudInterval,true);
		$ssScoreFriendlySwitch = 0;
		return;
	}
	if (%time !$= "")
		$ssScoreHudFriendlyTime = %time;
	else
		$ssScoreHudFriendlyTime -= $ssScoreHudInterval;
	%fmt = strLen(getSubStr($ssScoreHudInterval,(strStr($ssScoreHudInterval,".") == -1) ? 0 : strStr($ssScoreHudInterval,"."),1000))-1;
	SSFriendlyScoreHudText.setText("\c0\x8b\c7" @ mFormatFloat($ssScoreHudFriendlyTime,"%." @ (%fmt != -1 ? %fmt : 0) @ "f") @ "\c0\x9b");
	$ssScoreHudFriendlySchedule = schedule($ssScoreHudInterval*1000,0,ssScoreHudFriendlyTimer);
}

function ssScoreHudEnemyTimer(%time, %pass) {
	if ($ssScoreEnemySwitch != 0 && !%pass) {
		ssScoreHudFriendlyTimer($ssScoreEnemySwitch - $ssScoreHudInterval,true);
		$ssScoreEnemySwitch = 0;
		return;
	}
	if (%time !$= "")
		$ssScoreHudEnemyTime = %time;
	else
		$ssScoreHudEnemyTime -= $ssScoreHudInterval;
	%fmt = strLen(getSubStr($ssScoreHudInterval,(strStr($ssScoreHudInterval,".") == -1) ? 0 : strStr($ssScoreHudInterval,"."),1000))-1;
	SSEnemyScoreHudText.setText("\c0\x8b\c7" @ mFormatFloat($ssScoreHudEnemyTime,"%." @ (%fmt != -1 ? %fmt : 0) @ "f") @ "\c0\x9b");
	$ssScoreHudEnemySchedule = schedule($ssScoreHudInterval*1000,0,ssScoreHudEnemyTimer);
}

function ssScoreHudReset() {
	$ssScoreHudFriendlyScore = $ssScoreHudEnemyScore = 0;
	ssScoreHudDrawScores();
	SSFriendlyScoreHudText.setText("");
	cancel($ssScoreHudFriendlySchedule);
	SSFriendlyScoreHud.setBitmap("ssflag_friendly.png");
	SSEnemyScoreHudText.setText("");
	cancel($ssScoreHudEnemySchedule);
	SSEnemyScoreHud.setBitmap("ssflag_enemy.png");
	SSScoreHudCarrierName.setText("Center");
}

function ssScoreHudHandleTR2HudInit(%msgType, %msgString, %team1, %team2, %score1, %score2, %flagLoc, %carrierHealth) {
	$ssScoreHudFriendlyScore = ($ssScoreHudTeamId == 1) ? detag(%score1) : detag(%score2);
	$ssScoreHudEnemyScore = ($ssScoreHudTeamId == 1) ? detag(%score2) : detag(%score1);
	SSScoreHudCarrierName.setText(%flagLoc);
	SSScoreHudCarrierHealth.setValue(%carrierHealth);
	SSFriendlyScoreHud.setBitmap("ssflag_friendly.png");
	SSEnemyScoreHud.setBitmap("ssflag_enemy.png");
	ssScoreHudDrawScores();
}

function ssScoreHudHandleTR2SetScore(%msgType, %msgString, %team, %score) {
	if ($ssScoreHudTeamId == %team)
		$ssScoreHudFriendlyScore = %score;
	else
		$ssScoreHudEnemyScore = %score;
	ssScoreHudDrawScores();
}

function ssScoreHudHandleTR2FlagStatus(%msgType, %msgString, %location) {
	SSScoreHudCarrierName.setText(detag(%location));
}

function ssScoreHudHandleTR2FlagTaken(%msgType, %msgString, %client, %team, %flagteam, %clientnamebase) {
	SSScoreHudCarrierName.setText(detag(%client));
}

function ssScoreHudHandleTR2FlagDropped(%msgType, %msgString, %client, %team, %flagteam) {
	SSScoreHudCarrierName.setText("Dropped");
	SSFriendlyScoreHud.setBitmap("ssflag_friendly.png");
	SSEnemyScoreHud.setBitmap("ssflag_enemy.png");
}

function ssScoreHudHandleTR2CarrierHealth(%msgType, %msgString, %amt, %team) {
	if (%team == 1) {
		SSScoreHudCarrierHealth.profile.fillColor = $TR2::Color::CarrierFriendly;
		SSFriendlyScoreHud.setBitmap("ssflag_friendly_taken.png");
	} else {
		SSScoreHudCarrierHealth.profile.fillColor = $TR2::Color::CarrierEnemy;
		SSEnemyScoreHud.setBitmap("ssflag_enemy_taken.png");
	}
	SSScoreHudCarrierHealth.setValue(%amt);
}

function ssMakeScoreHud() {
	new GuiControlProfile(SSScoreHudTextProfile) {
		fontType = "Univers";
		fontSize = 15;
		fontColor = $PlayerNameColor;
		fontColors[6] = $PlayerNameColor;
		fontColors[7] = $TribeTagColor;
		fontColors[8] = $SmurfNameColor;
		fontColors[9] = $BotNameColor;
		justify = "left";
	};
	
	new GuiControlProfile(SSScoreHudCarrierNameProfile) {
		fontType = "Univers";
		fontSize = 15;
		fontColor = $PlayerNameColor;
		fontColors[6] = $PlayerNameColor;
		fontColors[7] = $TribeTagColor;
		fontColors[8] = $SmurfNameColor;
		fontColors[9] = $BotNameColor;
		justify = "left";
	};

	new GuiControlProfile(SSScoreHudScoreProfile) {
		fontType = "Univers Bold";
		fontSize = 15;
		fontColor = $PlayerNameColor;
		justify = "center";
	};
	
	new GuiControl(SSFriendlyScoreHudFrame) {
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "200 15";
		minExtent = "8 8";
		visible = "1";

		new HudBitmapCtrl(SSFriendlyScoreHud) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "30 0";
			extent = "15 15";
			minExtent = "8 8";
			visible = "1";
			opacity = "0.5";
			bitmap = "ssflag_friendly.png";
			autoResize = "1";

		};
		new GuiTextCtrl(SSFriendlyScoreHudText) {
			profile = "SSScoreHudTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "48 0";
			extent = "152 15";
			minExtent = "8 8";
			visible = "1";
			maxLength = "255";
		};
		new GuiTextCtrl(SSFriendlyScoreHudScore) {
			profile = "SSScoreHudScoreProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "30 15";
			minExtent = "8 8";
			visible = "1";
			maxLength = "255";
		};
		new GuiTextCtrl(SSScoreHudCarrierName) {
			profile = "SSScoreHudCarrierNameProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "48 0";
			extent = "152 15";
			minExtent = "8 8";
			visible = "0";
			maxLength = "255";
			text = "Center";
		};
	};

	new GuiControl(SSEnemyScoreHudFrame) {
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "200 15";
		minExtent = "8 8";
		visible = "1";

		new HudBitmapCtrl(SSEnemyScoreHud) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "30 0";
			extent = "15 15";
			minExtent = "8 8";
			visible = "1";
			opacity = "0.5";
			bitmap = "ssflag_enemy.png";
			autoResize = "1";
		};
		new GuiTextCtrl(SSEnemyScoreHudText) {
			profile = "SSScoreHudTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "48 0";
			extent = "152 15";
			minExtent = "8 8";
			visible = "1";
			maxLength = "255";
		};
		new GuiTextCtrl(SSEnemyScoreHudScore) {
			profile = "SSScoreHudScoreProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "30 15";
			minExtent = "8 8";
			visible = "1";
			maxLength = "255";
		};
		new GuiProgressCtrl(SSScoreHudCarrierHealth) {
			profile = "TR2CarrierHealth";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "48 3";
			extent = "93 10";
			minExtent = "8 8";
			visible = "0";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
		};
	};
	playGui.add(SSFriendlyScoreHudFrame);
	playGui.add(SSEnemyScoreHudFrame);
	if (isObject(HM) && isObject(HudMover)) {
		hudmover::addhud(SSFriendlyScoreHudFrame, "Friendly Score/Flag");
		hudmover::addhud(SSEnemyScoreHudFrame, "Enemy Score/Flag");
	}
	addMessageCallback('MsgCTFFlagTaken', ssScoreHudHandleFlag);
	addMessageCallback('MsgCTFFlagDropped', ssScoreHudHandleFlag);
	addMessageCallback('MsgCTFFlagReturned', ssScoreHudHandleFlag);
	addMessageCallback('MsgCTFFlagCapped', ssScoreHudHandleFlag);
	addMessageCallback('MsgTeamScoreIs', ssScoreHudHandleScore);
	addMessageCallback('MsgTeamScore', ssScoreHudHandleScore);
	addMessageCallback('MsgGameOver', ssScoreHudReset);
	addMessageCallback('MsgCheckTeamLines', ssScoreHudHandleCheckTeamLines);
	addMessageCallback('MsgCTFAddTeam', ssScoreHudHandleCTFAddTeam);
	addMessageCallback('MsgTR2ObjInit', ssScoreHudHandleTR2HudInit);
	addMessageCallback('MsgTR2SetScore', ssScoreHudHandleTR2SetScore);
	addMessageCallback('MsgTR2FlagStatus', ssScoreHudHandleTR2FlagStatus);
	addMessageCallback('MsgTR2FlagTaken', ssScoreHudHandleTR2FlagTaken);
	addMessageCallback('MsgTR2FlagDropped', ssScoreHudHandleTR2FlagDropped);
	addMessageCallback('MsgTR2CarrierHealth', ssScoreHudHandleTR2CarrierHealth);
}
